/*
 *
 *  Copyright (C) 2014 Jürg Müller, CH-5524
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation version 3 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program. If not, see http://www.gnu.org/licenses/ .
 */

#if !defined(KCanElster_H) 

  #define KCanElster_H

  #include "KCanServer.h"

  struct KSniffFrame : KCanFrame
  {
    KSniffFrame * Next;
    
    void SetValue(unsigned Value);
    unsigned GetValue() const;
  };

  class KCanElster : public KCanServer
  {
    private:
      KSniffFrame * Sniffed[256];
      
      void InitSendFrame(unsigned short receiver_id, unsigned short TelegrammId);
      bool Send_Frame();
      bool SniffFrame();
      bool Get_Frame();
      
    public:
      bool Trace;
      unsigned short SendCanId;
      KCanFrame SendFrame;
      KCanFrame RecvFrame;
      bool UsedCanId[256];
      
      KCanElster();
      ~KCanElster();
  
      bool Init(const char * CanDev, unsigned short DefaultId = 0x700);
      bool AddToSniffed(const KCanFrame & Frame);
      bool Send(unsigned count = 3, bool WaitForAnswer = true);
      bool GetValue(unsigned short receiver_id, unsigned short TelegrammId, unsigned short & Value);
      bool SetValue(unsigned short receiver_id, unsigned short TelegrammId, unsigned short Value);
      bool SetValue();
      void Scanner(unsigned short receiver_id, bool get_all);
      void GetValidDevices(); // try with Elster-Index 0x000b; if it aswers, it is a valid device
      void EmptyServer();
      KSniffFrame * SearchSniffFrame(const KCanFrame & Frame);
      bool GetInitCS_Id(); // result is in: KComfortFrame::InitId
        
      static void PrintFrame(const KCanFrame & Frame);
      void PrintSendFrame();
      void PrintRecvFrame();
      
  };

#endif

